%global commit      c33c89f33e90c27be45d47ab67818f0bebaf2c3b
%global shortcommit %(c=%{commit}; echo ${c:0:7})
%global date        20190912

# Git submodules
%global qmarkdowntextedit_commit        ba025b02bc3cf640b9b0e57245a52f130744af8b
%global qmarkdowntextedit_shortcommit   %(c=%{qmarkdowntextedit_commit}; echo ${c:0:7})

%global qttoolbareditor_commit          612029c45b7b6c38be8ffe7c600ae6a10edb9006
%global qttoolbareditor_shortcommit     %(c=%{qttoolbareditor_commit}; echo ${c:0:7})

%global qtcsv_commit                    db3e9a816d91a4773b61312cafa25eff4ddec91c
%global qtcsv_shortcommit               %(c=%{qtcsv_commit}; echo ${c:0:7})

%global fakevim_commit                  8f1a58e5e2aff87a0bf40b078e32ae2779dca213
%global fakevim_shortcommit             %(c=%{fakevim_commit}; echo ${c:0:7})

%global qtpiwiktracker_commit           209b66d4e76d2ed6d60c1b06ea324f23d7fa4e10
%global qtpiwiktracker_shortcommit      %(c=%{qtpiwiktracker_commit}; echo ${c:0:7})

%global qkeysequencewidget_commit       9f3f19f7e96a001a98a3216fb65381359da8c39e
%global qkeysequencewidget_shortcommit  %(c=%{qkeysequencewidget_commit}; echo ${c:0:7})


%global appname QOwnNotes
%global url1    https://github.com/pbek

Name:           qownnotes
Version:        19.9.12
Release:        1.%{date}git%{shortcommit}%{?dist}
Summary:        Plain-text file markdown note taking with Nextcloud integration

# The entire source code is MIT except bundled libs:
# BSD:          qdarkstyle
#               qkeysequencewidget
#               qmarkdowntextedit
#               singleapplication
#               simplecrypt
# MIT:          piwiktracker
# GPLv2         versionnumber
# GPLv3+        qttoolbareditor
# LGPLv2+       fakevim
# ASL 2.0       diff_match_patch
License:        MIT and BSD and GPLv2 and GPLv3+ and LGPLv2+ and ASL 2.0
URL:            https://www.qownnotes.org
Source0:        %{url1}/QOwnNotes/archive/%{commit}/%{name}-%{version}.%{date}git%{shortcommit}.tar.gz
Source1:        %{url1}/qmarkdowntextedit/archive/%{qmarkdowntextedit_commit}/qmarkdowntextedit-%{qmarkdowntextedit_shortcommit}.tar.gz
Source2:        %{url1}/Qt-Toolbar-Editor/archive/%{qttoolbareditor_commit}/qttoolbareditor-%{qttoolbareditor_shortcommit}.tar.gz
Source3:        %{url1}/qtcsv/archive/%{qtcsv_commit}/qtcsv-%{qtcsv_shortcommit}.tar.gz
Source4:        %{url1}/FakeVim/archive/%{fakevim_commit}/fakevim-%{fakevim_shortcommit}.tar.gz
Source5:        %{url1}/qt-piwik-tracker/archive/%{qtpiwiktracker_commit}/qtpiwiktracker-%{qtpiwiktracker_shortcommit}.tar.gz
Source6:        %{url1}/qkeysequencewidget/archive/%{qkeysequencewidget_commit}/qkeysequencewidget-%{qkeysequencewidget_shortcommit}.tar.gz
ExcludeArch:    s390x ppc64le

BuildRequires:  cmake3
BuildRequires:  cmake(Qt5)
BuildRequires:  cmake(Qt5Core)
BuildRequires:  cmake(Qt5DBus)
BuildRequires:  cmake(Qt5LinguistTools)
BuildRequires:  cmake(Qt5Multimedia)
BuildRequires:  cmake(Qt5PrintSupport)
BuildRequires:  cmake(Qt5Sql)
BuildRequires:  cmake(Qt5Svg)
BuildRequires:  cmake(Qt5WebSockets)
BuildRequires:  cmake(Qt5Xml)
BuildRequires:  cmake(Qt5XmlPatterns)
BuildRequires:  desktop-file-utils
BuildRequires:  gcc-c++
BuildRequires:  libappstream-glib
BuildRequires:  ninja-build
# Filed a bug in upstream to switch on 'botan2'
# https://github.com/pbek/QOwnNotes/issues/1263
%if 0%{?fedora} < 31
BuildRequires:  pkgconfig(botan-1.10)
%endif
Requires:       hicolor-icon-theme
Requires:       qt5-qtbase%{?_isa}
Recommends:     %{name}-translations
Provides:       bundled(fakevim) = 0.0.1
Provides:       bundled(qkeysequencewidget) = 1.0.1
Provides:       bundled(qmarkdowntextedit) = 2019.4.0~git%{qmarkdowntextedit_shortcommit}
Provides:       bundled(qt-piwik-tracker) = 0~git%{qtpiwiktracker_shortcommit}
Provides:       bundled(qt-toolbar-editor) = 0~git%{qttoolbareditor_shortcommit}
Provides:       bundled(qtcsv) = 1.2.2
%if 0%{?fedora} >= 31
Provides:       bundled(botan) = 1.10.2
%endif

%description
QOwnNotes is the open source notepad with markdown support and todo list
manager for GNU/Linux, Mac OS X and Windows, that works together with the
default notes application of ownCloud and Nextcloud.

You are able to write down your thoughts with QOwnNotes and edit or search for
them later from your mobile device, like with CloudNotes or the
ownCloud / Nextcloud web-service.

The notes are stored as plain text files and are synced with
ownCloud's / Nextcloud's file sync functionality. Of course other software,
like Syncthing or Dropbox can be used too.

I like the concept of having notes accessible in plain text files, like it is
done in the ownCloud / Nextcloud notes apps, to gain a maximum of freedom, but
I was not able to find a decent desktop note taking tool or a text editor, that
handles them well. Out of this need QOwnNotes was born.


%package        translations
BuildArch:      noarch

Summary:        Translations files for %{name}
Requires:       %{name} = %{version}-%{release}

%description    translations
Translations files for %{name}.


%prep
%autosetup -p1 -n  %{appname}-%{commit}
%autosetup     -n  %{appname}-%{commit} -D -T -a 1
%autosetup     -n  %{appname}-%{commit} -D -T -a 2
%autosetup     -n  %{appname}-%{commit} -D -T -a 3
%autosetup     -n  %{appname}-%{commit} -D -T -a 4
%autosetup     -n  %{appname}-%{commit} -D -T -a 5
%autosetup     -n  %{appname}-%{commit} -D -T -a 6

mv qmarkdowntextedit-%{qmarkdowntextedit_commit}/*      src/libraries/qmarkdowntextedit/
mv Qt-Toolbar-Editor-%{qttoolbareditor_commit}/*        src/libraries/qttoolbareditor/
mv qtcsv-%{qtcsv_commit}/*                              src/libraries/qtcsv/
mv FakeVim-%{fakevim_commit}/*                          src/libraries/fakevim/
mv qt-piwik-tracker-%{qtpiwiktracker_commit}/*          src/libraries/piwiktracker/
mv qkeysequencewidget-%{qkeysequencewidget_commit}/*    src/libraries/qkeysequencewidget/
mkdir -p %{_target_platform}


%build
pushd %{_target_platform}
    %cmake3 -G Ninja \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    %if 0%{?fedora} < 31
    -DUSE_SYSTEM_BOTAN=1 \
    %endif
    ..
popd
%ninja_build -C %{_target_platform}


%install
%ninja_install -C %{_target_platform}
pushd %{_target_platform}/src
install -Dm0755 %{appname}                                  %{buildroot}/%{_bindir}/%{appname}
popd
pushd src
install -Dpm0644 images/icons/128x128/apps/%{appname}.png   %{buildroot}/%{_datadir}/icons/hicolor/128x128/apps/%{appname}.png
install -Dpm0644 images/icons/16x16/apps/%{appname}.png     %{buildroot}/%{_datadir}/icons/hicolor/16x16/apps/%{appname}.png
install -Dpm0644 images/icons/24x24/apps/%{appname}.png     %{buildroot}/%{_datadir}/icons/hicolor/24x24/apps/%{appname}.png
install -Dpm0644 images/icons/256x256/apps/%{appname}.png   %{buildroot}/%{_datadir}/icons/hicolor/256x256/apps/%{appname}.png
install -Dpm0644 images/icons/32x32/apps/%{appname}.png     %{buildroot}/%{_datadir}/icons/hicolor/32x32/apps/%{appname}.png
install -Dpm0644 images/icons/48x48/apps/%{appname}.png     %{buildroot}/%{_datadir}/icons/hicolor/48x48/apps/%{appname}.png
install -Dpm0644 images/icons/512x512/apps/%{appname}.png   %{buildroot}/%{_datadir}/icons/hicolor/512x512/apps/%{appname}.png
install -Dpm0644 images/icons/64x64/apps/%{appname}.png     %{buildroot}/%{_datadir}/icons/hicolor/64x64/apps/%{appname}.png
install -Dpm0644 images/icons/96x96/apps/%{appname}.png     %{buildroot}/%{_datadir}/icons/hicolor/96x96/apps/%{appname}.png
install -Dpm0644 images/icons/128x128/apps/%{appname}.png   %{buildroot}/%{_datadir}/pixmaps/%{appname}.png
install -Dpm0644 PBE.%{appname}.desktop                     %{buildroot}/%{_datadir}/applications/PBE.%{appname}.desktop
popd
install -Dpm0644 obs/%{name}.appdata.xml                    %{buildroot}/%{_metainfodir}/%{name}.appdata.xml
%find_lang %{appname} --with-qt


%check
appstream-util validate-relax --nonet %{buildroot}%{_metainfodir}/%{name}.appdata.xml
desktop-file-validate %{buildroot}%{_datadir}/applications/PBE.%{appname}.desktop


%files
%license LICENSE
%doc README.md SHORTCUTS.md
%{_bindir}/%{appname}
%{_datadir}/applications/*.desktop
%{_datadir}/icons/hicolor/*/*/*.png
%{_datadir}/pixmaps/*.png
%{_metainfodir}/*.xml


%files -f %{appname}.lang translations
%{_datadir}/qt5/translations/%{appname}_ceb.qm
%{_datadir}/qt5/translations/%{appname}_fil.qm
%{_datadir}/qt5/translations/%{appname}_hil.qm

%changelog
* Tue Sep 17 2019 Artem Polishchuk <ego.cordatus@gmail.com> - 19.9.12-1.20190912gitc33c89f
- Update to 19.9.12

* Sun Sep 08 2019 Artem Polishchuk <ego.cordatus@gmail.com> - 19.9.5-1.20190905gitf62ac68
- Update to 19.9.5

* Sat Aug 10 2019 Artem Polishchuk <ego.cordatus@gmail.com> - 1.8.4-7.20190810git0302b2c
- Initial package
- Thanks to Dead_Mozay <dead_mozay@opensuse.org> for initial spec file
